function d=data
global Tk
% Gives a struct with data needed to solve the model
% Properties for ammonia
d.MW = 17; %g/mol
d.R = 8.31451; % J/(mol K)
d.Cpl = 4.5837*d.MW; % J/(mol K)
d.Cpg = 2.5772*d.MW; % J/(mol K)
d.hvap = 1.2806e+03*d.MW; % J/(mol K)
d.Tref = 267.79; % K
d.As = [-7.296510;
	1.618053;
	-1.956546;
	-2.114118];
d.Tc = 405.4; % K
d.Pc = 111.85*1.013e5; % Pa
d.Ucon = [400;
          700;
          1000*ones(3,1)];
d.Uvap = 1000;
d.Vcon = 0.5;
d.Vvap = 1;
d.ncon_sub = 3;
